#include <algorithm>
#include <set>
#include <map>
#include <iostream>
#include <vector>
#include <string>
#include <cstdio>
#include <cmath>
#include <cstdlib>

using namespace std;

#define VAR(i,e) __typeof(e) i = (e)
#define FOREACH(i, c) for(VAR(i,(c).begin()); i != (c).end(); ++i)
#define ALL(c) (c).begin(), (c).end()

#define FORI(x, p) for(int i = x; i < p; ++i)
#define FORJ(x, p) for(int j = x; j < p; ++j)
#define FORK(x, p) for(int k = x; k < p; ++k)
#define FORL(x, p) for(int l = x; l < p; ++l)

#define PB push_back
#define MP make_pair
#define S size()
#define X first
#define Y second

#define VI vector<int>
#define VVI vector<vector<int> >
#define VS vector<string>

VI tosvi(const VI & vi, int x){
    VI r;
    int pos = vi.S - 1;
    while(x > 0){
	if(x % 2)r.PB(vi[pos]);
	--pos;
	x /= 2;
    }
    return r;
}

int main(){
    int d;
    cin >> d;
    FORL(0, d){
	int n, k;
	cin >> n >> k;
	VVI vvi;
	FORI(0, n){
	    VI vi;
	    FORJ(0, k){
		int t;
		cin >> t;
		vi.PB(t);
	    }
	    vvi.PB(vi);
	}

	sort(ALL(vvi));
	vvi.erase(unique(ALL(vvi)), vvi.end());

	set<VI> svi;
	FOREACH(it, vvi){
	    FORI(1, 1 << k){
		svi.insert(tosvi(*it, i));
	    }
	}
	cout << svi.S << endl;
    }
}
